<template>
  <span>
    <coscine-form-group
      :mandatory="true"
      labelFor="ResourceName"
      :label="$t('ResourceNameLabel')"
      :isLoading="isLoading"
      type="input"
    >
      <b-form-input
        id="ResourceName"
        v-model="$v.resource.ResourceName.$model"
        @input="translateResourceNameToDisplayName"
        aria-describedby="ResourceNameHelp"
        :state="
          $v.resource.ResourceName.$dirty
            ? !$v.resource.ResourceName.$error
            : null
        "
        :placeholder="$t('ResourceName')"
        maxlength="200"
        required="required"
        :disabled="!isOwner"
      />
      <div class="invalid-tooltip">{{ $t("ResourceNameHelp") }}</div>
    </coscine-form-group>
    <coscine-form-group
      :mandatory="true"
      labelFor="DisplayName"
      :label="$t('DisplayNameLabel')"
      :isLoading="isLoading"
      type="input"
    >
      <b-form-input
        id="DisplayName"
        v-model="$v.resource.DisplayName.$model"
        @input="lockDisplayName"
        aria-describedby="DisplayNameHelp"
        :state="
          $v.resource.DisplayName.$dirty
            ? !$v.resource.DisplayName.$error
            : null
        "
        :placeholder="$t('DisplayName')"
        maxlength="25"
        required="required"
        :disabled="!isOwner"
      />
      <div class="invalid-tooltip">{{ $t("DisplayNameHelp") }}</div>
    </coscine-form-group>
    <coscine-form-group
      :mandatory="true"
      labelFor="Description"
      :label="$t('ResourceDescriptionLabel')"
      :isLoading="isLoading"
      type="input"
    >
      <b-form-textarea
        id="Description"
        v-model="$v.resource.Description.$model"
        aria-describedby="ResourceDescriptionHelp"
        :state="
          $v.resource.Description.$dirty
            ? !$v.resource.Description.$error
            : null
        "
        :placeholder="$t('ResourceDescription')"
        maxlength="5000"
        required="required"
        :disabled="!isOwner"
      />
      <div class="invalid-tooltip">{{ $t("ResourceDescriptionHelp") }}</div>
    </coscine-form-group>
    <coscine-form-group
      :mandatory="true"
      labelFor="Disciplines"
      :label="$t('ResourceDisciplineLabel')"
      class="disciplineFormGroup"
      :isLoading="isLoading"
      type="input"
    >
      <multiselect
        id="Disciplines"
        v-model="resource.Disciplines"
        :disabled="!isOwner"
        :options="disciplines"
        :multiple="true"
        :hide-selected="true"
        :label="disciplineLabel"
        :track-by="disciplineLabel"
        :placeholder="$t('ResourceDiscipline')"
      >
      </multiselect>
    </coscine-form-group>
    <coscine-form-group
      labelFor="Keywords"
      :label="$t('ResourceKeywordsLabel')"
      :isLoading="isLoading"
      type="input"
    >
      <multiselect
        id="Keywords"
        v-model="resource.Keywords"
        :disabled="!isOwner"
        :options="keywordoptions"
        :placeholder="$t('ResourceKeywords')"
        :multiple="true"
        :taggable="true"
        :tag-placeholder="$t('TagPlaceholder')"
        @tag="addTag"
      ></multiselect>
    </coscine-form-group>
    <coscine-form-group
      :mandatory="true"
      labelFor="Visibility"
      :label="$t('ResourceVisibilityLabel')"
      :isLoading="isLoading"
      type="input"
    >
      <b-form-radio-group
        v-model="resource.Visibility"
        :options="visibilities"
        name="radios-stacked"
        stacked
        :disabled="!isOwner"
      ></b-form-radio-group>
    </coscine-form-group>

    <!-- License -->
    <coscine-form-group
      labelFor="ResourceLicense"
      :label="$t('ResourceLicenseLabel')"
      :isLoading="isLoading"
      type="input"
      :info="true"
    >
      <template #popover>
        {{ $t("popoverLicense") }}
        <b-link
          href="https://help.itc.rwth-aachen.de/service/b2b7729fd93f4c7080b475776f6b5d87/article/7812e3fcd3a241808f5b91e11b6ca3a9/"
          target="_blank"
          >{{ $t("help") }}</b-link
        >
      </template>

      <b-form-select
        id="ResourceLicense"
        v-model="resource.License"
        :options="licenses"
        :placeholder="$t('ResourceLicense')"
        :disabled="!isOwner"
      >
        <template v-slot:first>
          <option :value="null">
            {{ $t("SelectResourceLicense") }}
          </option>
        </template>
      </b-form-select>
    </coscine-form-group>

    <!-- Usage Rights -->
    <coscine-form-group
      labelFor="UsageRights"
      :label="$t('ResourceUsageRightsLabel')"
      :isLoading="isLoading"
      type="input"
      :info="true"
    >
      <template #popover>
        {{ $t("popoverUsageRights") }}
        <b-link
          href="https://help.itc.rwth-aachen.de/service/b2b7729fd93f4c7080b475776f6b5d87/article/7812e3fcd3a241808f5b91e11b6ca3a9/"
          target="_blank"
          >{{ $t("help") }}</b-link
        >
      </template>

      <b-form-input
        id="UsageRights"
        v-model="$v.resource.UsageRights.$model"
        aria-describedby="UsageRightsHelp"
        :state="
          $v.resource.UsageRights.$dirty
            ? !$v.resource.UsageRights.$error
            : null
        "
        :placeholder="$t('ResourceUsageRights')"
        maxlength="500"
        required="required"
        :disabled="!isOwner"
      />
      <div class="invalid-tooltip">{{ $t("ResourceUsageRightsHelp") }}</div>
    </coscine-form-group>
  </span>
</template>

<script lang="ts">
import Vue from "vue";
import { CoscineFormGroup } from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";

import { validationMixin } from "vuelidate";
import {
  required,
  minLength,
  maxLength,
  integer,
} from "vuelidate/lib/validators";

import Multiselect from "vue-multiselect";
import "vue-multiselect/dist/vue-multiselect.min.css";
Vue.component("multiselect", Multiselect);

function checkKeywords(value: any) {
  // check if the total sum of characters for keywords is <= 1000
  let count = 0;
  if (typeof value === "string") {
    count = value.length;
  } else if (value !== undefined) {
    for (const keyword of value) {
      count += keyword.length;
    }
  }
  return count <= 1000;
}

export default Vue.extend({
  name: "GeneralInfo",
  components: {
    CoscineFormGroup,
  },
  validations: {
    resource: {
      ResourceName: {
        required,
        maxLength: maxLength(200),
      },
      DisplayName: {
        required,
        maxLength: maxLength(25),
      },
      Description: {
        required,
        maxLength: maxLength(5000),
      },
      Disciplines: {
        required,
      },
      Licence: {},
      Keywords: {
        checkKeywords,
      },
      Visibility: {
        required,
      },
      UsageRights: {
        maxLength: maxLength(500),
      },
    },
  },
  props: {
    resource: Object,
    isOwner: {
      default: false,
      type: Boolean,
    },
    isLoading: {
      default: false,
      type: Boolean,
    },
    displayNameIsLocked: Boolean,
    licenses: Array,
    disciplines: Array,
    visibilities: Array,
    keywordoptions: Array,
    disciplineLabel: String,
  },
  methods: {
    translateResourceNameToDisplayName() {
      this.$emit("translateResourceNameToDisplayName");
    },
    addTag(val: any) {
      this.$emit("addTag", val);
    },
    lockDisplayName() {
      this.$emit("lockDisplayName");
    },
  },
});
</script>

<style>
.general-information .multiselect {
  height: calc(1.4em + 0.75rem + 2px);
}
.general-information .multiselect__input {
  border: 0px;
  height: calc(1.4em + 0.75rem + 2px);
}
.general-information .multiselect__tags {
  border-radius: 0px;
}
.disciplineFormGroup > div {
  max-width: 75%;
}
.general-information .multiselect__tag {
  white-space: normal;
}
.general-information .vdp-datepicker__calendar-button {
  height: calc(1.4em + 0.75rem + 2px);
}
.general-information .col-form-label {
  font-weight: bold;
}
.multiselect {
  height: auto !important;
}
.multiselect__tag {
  background-color: #00549f !important;
}
.multiselect__option--highlight {
  background-color: #00549f !important;
  background: #00549f !important;
}
.multiselect__option--selected.multiselect__option--highlight {
  background-color: #a70619 !important;
}
.multiselect__tag-icon:focus,
.multiselect__tag-icon:hover {
  background-color: #a70619 !important;
}
.invalid-tooltip {
  position: absolute;
  top: 100%;
  z-index: 5;
  display: none;
  max-width: 100%;
  padding: 0.25rem 0.5rem;
  margin-top: 0.1rem;
  font-size: 0.76563rem;
  line-height: 1.4;
  color: #fff;
  background-color: rgba(204, 7, 30, 0.9);
  border-radius: 0;
}
</style>
